// Package api provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/oapi-codegen/oapi-codegen/v2 version v2.4.1 DO NOT EDIT.
package api

import (
	"bytes"
	"compress/gzip"
	"context"
	"encoding/base64"
	"encoding/json"
	"fmt"
	"io"
	"net/http"
	"net/url"
	"path"
	"strings"
	"time"

	"github.com/getkin/kin-openapi/openapi3"
	"github.com/go-chi/chi/v5"
	"github.com/oapi-codegen/runtime"
	strictnethttp "github.com/oapi-codegen/runtime/strictmiddleware/nethttp"
	openapi_types "github.com/oapi-codegen/runtime/types"
)

// Defines values for LogStatusCode.
const (
	STATUSCODEERROR LogStatusCode = "STATUS_CODE_ERROR"
	STATUSCODEOK    LogStatusCode = "STATUS_CODE_OK"
	STATUSCODEUNSET LogStatusCode = "STATUS_CODE_UNSET"
)

// Error The error that occured while processing this request.
type Error struct {
	Message string `json:"message"`
}

// Log The log object
type Log struct {
	// Duration duration of the trace in ms
	Duration             uint64             `json:"duration"`
	Organization         string             `json:"organization"`
	ParentSpanId         string             `json:"parentSpanId"`
	PersonalData         []string           `json:"personalData"`
	ProcessingActivity   string             `json:"processingActivity"`
	ProcessingActivityId openapi_types.UUID `json:"processingActivityId"`
	SpanId               string             `json:"spanId"`
	StartedAt            time.Time          `json:"startedAt"`

	// StatusCode The canonical status code that describes the result status of the operation.
	StatusCode LogStatusCode `json:"statusCode"`

	// StatusMessage An optional description of the status.
	StatusMessage string                 `json:"statusMessage"`
	Tags          map[string]interface{} `json:"tags"`
	TraceId       string                 `json:"traceId"`
}

// LogStatusCode The canonical status code that describes the result status of the operation.
type LogStatusCode string

// QueryID ID of the subject being queried.
type QueryID = string

// PathQueryID ID of the subject being queried.
type PathQueryID = QueryID

// BadRequestErrorResponse defines model for BadRequestErrorResponse.
type BadRequestErrorResponse struct {
	Errors []Error `json:"errors"`
}

// InternalErrorResponse defines model for InternalErrorResponse.
type InternalErrorResponse struct {
	Errors []Error `json:"errors"`
}

// LogResponse defines model for LogResponse.
type LogResponse struct {
	Data []Log `json:"data"`
}

// GetLogsParams defines parameters for GetLogs.
type GetLogsParams struct {
	// Since An optional RFC 3339 formatted time from which to query the logs. Default is 7 days ago.
	Since *time.Time `form:"since,omitempty" json:"since,omitempty"`

	// Until An optional RFC 3339 formatted time from which to query the logs. Default is now.
	Until *time.Time `form:"until,omitempty" json:"until,omitempty"`
}

// RequestEditorFn  is the function signature for the RequestEditor callback function
type RequestEditorFn func(ctx context.Context, req *http.Request) error

// Doer performs HTTP requests.
//
// The standard http.Client implements this interface.
type HttpRequestDoer interface {
	Do(req *http.Request) (*http.Response, error)
}

// Client which conforms to the OpenAPI3 specification for this service.
type Client struct {
	// The endpoint of the server conforming to this interface, with scheme,
	// https://api.deepmap.com for example. This can contain a path relative
	// to the server, such as https://api.deepmap.com/dev-test, and all the
	// paths in the swagger spec will be appended to the server.
	Server string

	// Doer for performing requests, typically a *http.Client with any
	// customized settings, such as certificate chains.
	Client HttpRequestDoer

	// A list of callbacks for modifying requests which are generated before sending over
	// the network.
	RequestEditors []RequestEditorFn
}

// ClientOption allows setting custom parameters during construction
type ClientOption func(*Client) error

// Creates a new Client, with reasonable defaults
func NewClient(server string, opts ...ClientOption) (*Client, error) {
	// create a client with sane default values
	client := Client{
		Server: server,
	}
	// mutate client and add all optional params
	for _, o := range opts {
		if err := o(&client); err != nil {
			return nil, err
		}
	}
	// ensure the server URL always has a trailing slash
	if !strings.HasSuffix(client.Server, "/") {
		client.Server += "/"
	}
	// create httpClient, if not already present
	if client.Client == nil {
		client.Client = &http.Client{}
	}
	return &client, nil
}

// WithHTTPClient allows overriding the default Doer, which is
// automatically created using http.Client. This is useful for tests.
func WithHTTPClient(doer HttpRequestDoer) ClientOption {
	return func(c *Client) error {
		c.Client = doer
		return nil
	}
}

// WithRequestEditorFn allows setting up a callback function, which will be
// called right before sending the request. This can be used to mutate the request.
func WithRequestEditorFn(fn RequestEditorFn) ClientOption {
	return func(c *Client) error {
		c.RequestEditors = append(c.RequestEditors, fn)
		return nil
	}
}

// The interface specification for the client above.
type ClientInterface interface {
	// GetLogs request
	GetLogs(ctx context.Context, queryID PathQueryID, params *GetLogsParams, reqEditors ...RequestEditorFn) (*http.Response, error)
}

func (c *Client) GetLogs(ctx context.Context, queryID PathQueryID, params *GetLogsParams, reqEditors ...RequestEditorFn) (*http.Response, error) {
	req, err := NewGetLogsRequest(c.Server, queryID, params)
	if err != nil {
		return nil, err
	}
	req = req.WithContext(ctx)
	if err := c.applyEditors(ctx, req, reqEditors); err != nil {
		return nil, err
	}
	return c.Client.Do(req)
}

// NewGetLogsRequest generates requests for GetLogs
func NewGetLogsRequest(server string, queryID PathQueryID, params *GetLogsParams) (*http.Request, error) {
	var err error

	var pathParam0 string

	pathParam0, err = runtime.StyleParamWithLocation("simple", false, "queryID", runtime.ParamLocationPath, queryID)
	if err != nil {
		return nil, err
	}

	serverURL, err := url.Parse(server)
	if err != nil {
		return nil, err
	}

	operationPath := fmt.Sprintf("/logs/%s", pathParam0)
	if operationPath[0] == '/' {
		operationPath = "." + operationPath
	}

	queryURL, err := serverURL.Parse(operationPath)
	if err != nil {
		return nil, err
	}

	if params != nil {
		queryValues := queryURL.Query()

		if params.Since != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "since", runtime.ParamLocationQuery, *params.Since); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		if params.Until != nil {

			if queryFrag, err := runtime.StyleParamWithLocation("form", true, "until", runtime.ParamLocationQuery, *params.Until); err != nil {
				return nil, err
			} else if parsed, err := url.ParseQuery(queryFrag); err != nil {
				return nil, err
			} else {
				for k, v := range parsed {
					for _, v2 := range v {
						queryValues.Add(k, v2)
					}
				}
			}

		}

		queryURL.RawQuery = queryValues.Encode()
	}

	req, err := http.NewRequest("GET", queryURL.String(), nil)
	if err != nil {
		return nil, err
	}

	return req, nil
}

func (c *Client) applyEditors(ctx context.Context, req *http.Request, additionalEditors []RequestEditorFn) error {
	for _, r := range c.RequestEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	for _, r := range additionalEditors {
		if err := r(ctx, req); err != nil {
			return err
		}
	}
	return nil
}

// ClientWithResponses builds on ClientInterface to offer response payloads
type ClientWithResponses struct {
	ClientInterface
}

// NewClientWithResponses creates a new ClientWithResponses, which wraps
// Client with return type handling
func NewClientWithResponses(server string, opts ...ClientOption) (*ClientWithResponses, error) {
	client, err := NewClient(server, opts...)
	if err != nil {
		return nil, err
	}
	return &ClientWithResponses{client}, nil
}

// WithBaseURL overrides the baseURL.
func WithBaseURL(baseURL string) ClientOption {
	return func(c *Client) error {
		newBaseURL, err := url.Parse(baseURL)
		if err != nil {
			return err
		}
		c.Server = newBaseURL.String()
		return nil
	}
}

// ClientWithResponsesInterface is the interface specification for the client with responses above.
type ClientWithResponsesInterface interface {
	// GetLogsWithResponse request
	GetLogsWithResponse(ctx context.Context, queryID PathQueryID, params *GetLogsParams, reqEditors ...RequestEditorFn) (*GetLogsResponse, error)
}

type GetLogsResponse struct {
	Body         []byte
	HTTPResponse *http.Response
	JSON200      *LogResponse
	JSON400      *BadRequestErrorResponse
	JSON500      *InternalErrorResponse
}

// Status returns HTTPResponse.Status
func (r GetLogsResponse) Status() string {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.Status
	}
	return http.StatusText(0)
}

// StatusCode returns HTTPResponse.StatusCode
func (r GetLogsResponse) StatusCode() int {
	if r.HTTPResponse != nil {
		return r.HTTPResponse.StatusCode
	}
	return 0
}

// GetLogsWithResponse request returning *GetLogsResponse
func (c *ClientWithResponses) GetLogsWithResponse(ctx context.Context, queryID PathQueryID, params *GetLogsParams, reqEditors ...RequestEditorFn) (*GetLogsResponse, error) {
	rsp, err := c.GetLogs(ctx, queryID, params, reqEditors...)
	if err != nil {
		return nil, err
	}
	return ParseGetLogsResponse(rsp)
}

// ParseGetLogsResponse parses an HTTP response from a GetLogsWithResponse call
func ParseGetLogsResponse(rsp *http.Response) (*GetLogsResponse, error) {
	bodyBytes, err := io.ReadAll(rsp.Body)
	defer func() { _ = rsp.Body.Close() }()
	if err != nil {
		return nil, err
	}

	response := &GetLogsResponse{
		Body:         bodyBytes,
		HTTPResponse: rsp,
	}

	switch {
	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 200:
		var dest LogResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON200 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 400:
		var dest BadRequestErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON400 = &dest

	case strings.Contains(rsp.Header.Get("Content-Type"), "json") && rsp.StatusCode == 500:
		var dest InternalErrorResponse
		if err := json.Unmarshal(bodyBytes, &dest); err != nil {
			return nil, err
		}
		response.JSON500 = &dest

	}

	return response, nil
}

// ServerInterface represents all server handlers.
type ServerInterface interface {
	// Get logs for subject
	// (GET /logs/{queryID})
	GetLogs(w http.ResponseWriter, r *http.Request, queryID PathQueryID, params GetLogsParams)
}

// Unimplemented server implementation that returns http.StatusNotImplemented for each endpoint.

type Unimplemented struct{}

// Get logs for subject
// (GET /logs/{queryID})
func (_ Unimplemented) GetLogs(w http.ResponseWriter, r *http.Request, queryID PathQueryID, params GetLogsParams) {
	w.WriteHeader(http.StatusNotImplemented)
}

// ServerInterfaceWrapper converts contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler            ServerInterface
	HandlerMiddlewares []MiddlewareFunc
	ErrorHandlerFunc   func(w http.ResponseWriter, r *http.Request, err error)
}

type MiddlewareFunc func(http.Handler) http.Handler

// GetLogs operation middleware
func (siw *ServerInterfaceWrapper) GetLogs(w http.ResponseWriter, r *http.Request) {

	var err error

	// ------------- Path parameter "queryID" -------------
	var queryID PathQueryID

	err = runtime.BindStyledParameterWithOptions("simple", "queryID", chi.URLParam(r, "queryID"), &queryID, runtime.BindStyledParameterOptions{ParamLocation: runtime.ParamLocationPath, Explode: false, Required: true})
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "queryID", Err: err})
		return
	}

	// Parameter object where we will unmarshal all parameters from the context
	var params GetLogsParams

	// ------------- Optional query parameter "since" -------------

	err = runtime.BindQueryParameter("form", true, false, "since", r.URL.Query(), &params.Since)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "since", Err: err})
		return
	}

	// ------------- Optional query parameter "until" -------------

	err = runtime.BindQueryParameter("form", true, false, "until", r.URL.Query(), &params.Until)
	if err != nil {
		siw.ErrorHandlerFunc(w, r, &InvalidParamFormatError{ParamName: "until", Err: err})
		return
	}

	handler := http.Handler(http.HandlerFunc(func(w http.ResponseWriter, r *http.Request) {
		siw.Handler.GetLogs(w, r, queryID, params)
	}))

	for _, middleware := range siw.HandlerMiddlewares {
		handler = middleware(handler)
	}

	handler.ServeHTTP(w, r)
}

type UnescapedCookieParamError struct {
	ParamName string
	Err       error
}

func (e *UnescapedCookieParamError) Error() string {
	return fmt.Sprintf("error unescaping cookie parameter '%s'", e.ParamName)
}

func (e *UnescapedCookieParamError) Unwrap() error {
	return e.Err
}

type UnmarshalingParamError struct {
	ParamName string
	Err       error
}

func (e *UnmarshalingParamError) Error() string {
	return fmt.Sprintf("Error unmarshaling parameter %s as JSON: %s", e.ParamName, e.Err.Error())
}

func (e *UnmarshalingParamError) Unwrap() error {
	return e.Err
}

type RequiredParamError struct {
	ParamName string
}

func (e *RequiredParamError) Error() string {
	return fmt.Sprintf("Query argument %s is required, but not found", e.ParamName)
}

type RequiredHeaderError struct {
	ParamName string
	Err       error
}

func (e *RequiredHeaderError) Error() string {
	return fmt.Sprintf("Header parameter %s is required, but not found", e.ParamName)
}

func (e *RequiredHeaderError) Unwrap() error {
	return e.Err
}

type InvalidParamFormatError struct {
	ParamName string
	Err       error
}

func (e *InvalidParamFormatError) Error() string {
	return fmt.Sprintf("Invalid format for parameter %s: %s", e.ParamName, e.Err.Error())
}

func (e *InvalidParamFormatError) Unwrap() error {
	return e.Err
}

type TooManyValuesForParamError struct {
	ParamName string
	Count     int
}

func (e *TooManyValuesForParamError) Error() string {
	return fmt.Sprintf("Expected one value for %s, got %d", e.ParamName, e.Count)
}

// Handler creates http.Handler with routing matching OpenAPI spec.
func Handler(si ServerInterface) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{})
}

type ChiServerOptions struct {
	BaseURL          string
	BaseRouter       chi.Router
	Middlewares      []MiddlewareFunc
	ErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

// HandlerFromMux creates http.Handler with routing matching OpenAPI spec based on the provided mux.
func HandlerFromMux(si ServerInterface, r chi.Router) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseRouter: r,
	})
}

func HandlerFromMuxWithBaseURL(si ServerInterface, r chi.Router, baseURL string) http.Handler {
	return HandlerWithOptions(si, ChiServerOptions{
		BaseURL:    baseURL,
		BaseRouter: r,
	})
}

// HandlerWithOptions creates http.Handler with additional options
func HandlerWithOptions(si ServerInterface, options ChiServerOptions) http.Handler {
	r := options.BaseRouter

	if r == nil {
		r = chi.NewRouter()
	}
	if options.ErrorHandlerFunc == nil {
		options.ErrorHandlerFunc = func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		}
	}
	wrapper := ServerInterfaceWrapper{
		Handler:            si,
		HandlerMiddlewares: options.Middlewares,
		ErrorHandlerFunc:   options.ErrorHandlerFunc,
	}

	r.Group(func(r chi.Router) {
		r.Get(options.BaseURL+"/logs/{queryID}", wrapper.GetLogs)
	})

	return r
}

type BadRequestErrorResponseJSONResponse struct {
	Errors []Error `json:"errors"`
}

type InternalErrorResponseJSONResponse struct {
	Errors []Error `json:"errors"`
}

type LogResponseJSONResponse struct {
	Data []Log `json:"data"`
}

type GetLogsRequestObject struct {
	QueryID PathQueryID `json:"queryID"`
	Params  GetLogsParams
}

type GetLogsResponseObject interface {
	VisitGetLogsResponse(w http.ResponseWriter) error
}

type GetLogs200JSONResponse struct{ LogResponseJSONResponse }

func (response GetLogs200JSONResponse) VisitGetLogsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(200)

	return json.NewEncoder(w).Encode(response)
}

type GetLogs400JSONResponse struct {
	BadRequestErrorResponseJSONResponse
}

func (response GetLogs400JSONResponse) VisitGetLogsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(400)

	return json.NewEncoder(w).Encode(response)
}

type GetLogs500JSONResponse struct {
	InternalErrorResponseJSONResponse
}

func (response GetLogs500JSONResponse) VisitGetLogsResponse(w http.ResponseWriter) error {
	w.Header().Set("Content-Type", "application/json")
	w.WriteHeader(500)

	return json.NewEncoder(w).Encode(response)
}

// StrictServerInterface represents all server handlers.
type StrictServerInterface interface {
	// Get logs for subject
	// (GET /logs/{queryID})
	GetLogs(ctx context.Context, request GetLogsRequestObject) (GetLogsResponseObject, error)
}

type StrictHandlerFunc = strictnethttp.StrictHTTPHandlerFunc
type StrictMiddlewareFunc = strictnethttp.StrictHTTPMiddlewareFunc

type StrictHTTPServerOptions struct {
	RequestErrorHandlerFunc  func(w http.ResponseWriter, r *http.Request, err error)
	ResponseErrorHandlerFunc func(w http.ResponseWriter, r *http.Request, err error)
}

func NewStrictHandler(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: StrictHTTPServerOptions{
		RequestErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusBadRequest)
		},
		ResponseErrorHandlerFunc: func(w http.ResponseWriter, r *http.Request, err error) {
			http.Error(w, err.Error(), http.StatusInternalServerError)
		},
	}}
}

func NewStrictHandlerWithOptions(ssi StrictServerInterface, middlewares []StrictMiddlewareFunc, options StrictHTTPServerOptions) ServerInterface {
	return &strictHandler{ssi: ssi, middlewares: middlewares, options: options}
}

type strictHandler struct {
	ssi         StrictServerInterface
	middlewares []StrictMiddlewareFunc
	options     StrictHTTPServerOptions
}

// GetLogs operation middleware
func (sh *strictHandler) GetLogs(w http.ResponseWriter, r *http.Request, queryID PathQueryID, params GetLogsParams) {
	var request GetLogsRequestObject

	request.QueryID = queryID
	request.Params = params

	handler := func(ctx context.Context, w http.ResponseWriter, r *http.Request, request interface{}) (interface{}, error) {
		return sh.ssi.GetLogs(ctx, request.(GetLogsRequestObject))
	}
	for _, middleware := range sh.middlewares {
		handler = middleware(handler, "GetLogs")
	}

	response, err := handler(r.Context(), w, r, request)

	if err != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, err)
	} else if validResponse, ok := response.(GetLogsResponseObject); ok {
		if err := validResponse.VisitGetLogsResponse(w); err != nil {
			sh.options.ResponseErrorHandlerFunc(w, r, err)
		}
	} else if response != nil {
		sh.options.ResponseErrorHandlerFunc(w, r, fmt.Errorf("unexpected response type: %T", response))
	}
}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/9xXSXPbOBP9KygkR4qLJHrh6XNiJ+X6POOM7Vzi8qRAskkiJgEaaMiRXfrvUwApanXi",
	"2S5zk0h0473G64fmM81k00oBAjVNnmnLFGsAQfX/sPrNgJqfn9q/OehM8Ra5FDSh56dEFkSb9BtkaH8+",
	"2JU+9Si3r20s9ahgDdCEPvRZPKrgwXAFOU1QGfCozipomE3/VkFBE/omWEEKurc6WMYvFgubQrdSaHAY",
	"37H8Ch4MaDxTSqqr/p19lUmBIND+ZG1b84xZ6ME3bfE/r+3cKtmCQt5lBJvH/eIIjf4ZNLctXXgU562l",
	"ypRic9rhXFK9XSa9G5ZJV7eO0FZhxYzVPCdctAaJNhY65L7d4lwgKMHq/wrVE0GMuJePgrggUjFNZJYZ",
	"1fO9kOU/wDJnyF7N8UKWP2XoEr6G37XJMtC6MDWxgBxcl63fzYLpirrTXjcV9EXBiuGyKuSx4jWQVkmb",
	"l4uSYMU1UV0H2ObbpN6A1qx0xYPvrGlri7eQkjyCQPKopCjpwEOj4qLcYbvMsUvYHdB+6LUsSb9sG1Nu",
	"+kLsBC7fWDfBCggqlgHhgjSaerSQqmFIE2q4wIMp9WjDBW9MQ5NwgMYFQglOpFKVTPCnYa9VAT5CAyAQ",
	"yPf50y59z7ogCLxumTjPNyNTSMPxcZTG0cE4P4rDvdGgtBSsPu1lN0Tf0o+QSqkQcoamoR59Z1QJSoOa",
	"8QyEaRpQtsyDUNchb0bu7LopWFfzXiInGfIZx/lmwv4pcCRvor00dhJsFyM8HmeHaR6NDtk4Gk0hj0dp",
	"VExGURjHcRan07xgG+dmeL5vJ/0XC62R2Yqc4GboOBxPR1E0moQ343ESxUkYflmHkTOEEfIGXsiJRr+X",
	"OezXdcaEFDxjNelWkkzm0LVotzgF7bSrQJsal6t6QQ8mYDvVHrgVxfXNyc3n66/vL0/Pvn7+9frshnob",
	"zy7/v/Xg7Orq8mqtHbfR/7Jq+h27le43q8namyW6LtpBG4rJDFZS9V1ErFJBkRwEh3zpOgm5dJ2mGXIg",
	"XJMSQBB7g82YIBUg+XB67e/VLCudzFme8w7WpzWn6OaDAcqz9S2rDLZ+Ba2syJnFtoygmMLhYXocTtL4",
	"KC7Sg2gSF1lxlB/FcVykk5+a3zLroNItd+hJbHX9lvm80Ex7m3Rd1t7KKzeUuX3Q+5z54cdzmzvvfnZL",
	"wV4kNsDNGevHH40n0/jg8Og4dMTRjh80ob/fhqPju+coXLzdU8GFHQELubyxWdY1aMN4bduPl7xm6f9m",
	"ovRFTXfuzBt7oXFNGDkXTzyrkJx8Ou86rAXVcNTdpGkxz0A9grrnogTXUrW10W5W6AfPs8+fLkjkj6lH",
	"jbLbV4itToIATFv7YILIHwcgAqcgjo702r7UozNQukMW+aEfupulBcFaThM68UN/0pWmclIOalnq4Lmv",
	"/sI+KgF3T+EK0CihCatre1dq0jDMKstJt5DxwvZXfz6W2GAcVuD0I+CF7FS3Nq/f7h9sVkuC9Xl+4f3I",
	"Ha4+vCeTyeSYdK6JkBPrmKRQsrEzSFYRlN05OClZCj45hYJZ0+OaHJKczTVhpdwUlDPn8GAURjdhlIwn",
	"yTT2Q6eyL8svB5d19emgucic5Ifp7jVO/i/TE/Lx7/IyAnn953ndbX3/jMPwpZF2WBesz9ELj05fE/PS",
	"h9XCo/Fr4vd/q7jh1zQNU/NOyJ36C6mWcl9aanJLa1nSO+cn3cXTiXyzj7l48lnbar/3FV8APkp1H8xC",
	"p/HV6iQIRDvi4mmUsuweRD6Kxoe2pf3IF7z1uUyOwqPQBd4NILZldDYDNUfXqSyVpsPvr47VYl7cLf4I",
	"AAD//56DT11ZDwAA",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %w", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %w", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	res := make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	resolvePath := PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		pathToFile := url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
